(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@ionic/angular')) :
    typeof define === 'function' && define.amd ? define('ionic4-city-picker', ['exports', '@angular/core', '@angular/forms', '@ionic/angular'], factory) :
    (factory((global['ionic4-city-picker'] = {}),global.ng.core,global.ng.forms,global.angular));
}(this, (function (exports,core,forms,angular) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m)
            return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length)
                    o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var CITY_PICKER_VALUE_ACCESSOR = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: core.forwardRef(( /**
         * @return {?}
         */function () { return IonCityPicker; })),
        multi: true
    };
    var IonCityPicker = /** @class */ (function () {
        function IonCityPicker(pickerCtrl, changeDetectorRef) {
            this.pickerCtrl = pickerCtrl;
            this.changeDetectorRef = changeDetectorRef;
            this.cityIds = 0;
            this.inputId = "ion-city-" + this.cityIds++;
            this.labelId = this.inputId + "-lbl";
            this.cityValue = {};
            this.cityText = '';
            this.addPlaceholderClass = false;
            this.isExpanded = false;
            this.isLoadData = false;
            this.provinceCol = 0;
            this.cityCol = 0;
            this.regionCol = 0;
            this.onChange = ( /**
             * @param {?} randomNumber
             * @return {?}
             */function (randomNumber) { });
            this.onTouch = ( /**
             * @return {?}
             */function () { });
            /**
             * The value of the city string.
             */
            this.value = '';
            /**
             * The name of the control, which is submitted with the form data.
             */
            this.name = this.inputId;
            /**
             * If `true`, the user cannot interact with the city.
             */
            this.disabled = false;
            /**
             * If `true`, the city appears normal but is not interactive.
             */
            this.readonly = false;
            /**
             * \@input {string} The text to display on the picker's cancel button. Default: `Cancel`.
             */
            this.cancelText = 'Cancel';
            /**
             * \@input {string} The text to display on the picker's "Done" button. Default: `Done`.
             */
            this.doneText = 'Done';
            /**
             * \@input {CityPickerColumn} city data
             */
            this.citiesData = [];
            /**
             * \@input {string} separate
             */
            this.separator = '-';
            /**
             * \@output {any} Emitted when the city selection has changed.
             */
            this.ionChange = new core.EventEmitter();
            /**
             * \@output {any} Emitted when the city selection was cancelled.
             */
            this.ionCancel = new core.EventEmitter();
            /**
             * Emitted when the styles change.
             * \@internal
             */
            this.ionStyle = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        IonCityPicker.prototype.ngAfterContentInit = /**
         * @return {?}
         */
            function () {
                this.cityText = this.value;
                if (this.cityText === '') {
                    this.cityText = this.placeholder != null ? this.placeholder : '';
                }
                this.hasReadonly();
                this.hasDisable();
                this.updateCityValue(this.value);
                this.emitStyle();
            };
        /**
         * @return {?}
         */
        IonCityPicker.prototype.ngAfterContentChecked = /**
         * @return {?}
         */
            function () {
                if (this.isLoadData || this.citiesData.length === 0) {
                    return;
                }
                this.hasPlaceholder();
                this.updateCityValue(this.value);
                this.isLoadData = true;
            };
        /**
         * @param {?} val
         * @return {?}
         */
        IonCityPicker.prototype.writeValue = /**
         * @param {?} val
         * @return {?}
         */
            function (val) {
                this.setValue(val);
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        IonCityPicker.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onChange = fn;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        IonCityPicker.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onTouch = fn;
            };
        /**
         * @param {?} ev
         * @return {?}
         */
        IonCityPicker.prototype.onClick = /**
         * @param {?} ev
         * @return {?}
         */
            function (ev) {
                if (ev.detail === 0) {
                    // do not continue if the click event came from a form submit
                    return;
                }
                this.setFocus();
                this.open();
            };
        /**
         * @private
         * @return {?}
         */
        IonCityPicker.prototype.open = /**
         * @private
         * @return {?}
         */
            function () {
                return __awaiter(this, void 0, void 0, function () {
                    var pickerOptions, picker;
                    var _this = this;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (this.disabled || this.isExpanded) {
                                    return [2 /*return*/];
                                }
                                pickerOptions = this.generatePickerOptions();
                                return [4 /*yield*/, this.pickerCtrl.create(pickerOptions)];
                            case 1:
                                picker = _a.sent();
                                this.isExpanded = true;
                                picker.onDidDismiss().then(( /**
                                 * @return {?}
                                 */function () {
                                    _this.isExpanded = false;
                                    _this.setFocus();
                                }));
                                picker.addEventListener('ionPickerColChange', ( /**
                                 * @param {?} event
                                 * @return {?}
                                 */function (event) {
                                    return __awaiter(_this, void 0, void 0, function () {
                                        var data, colSelectedIndex, colOptions, changeData, columns;
                                        return __generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0:
                                                    data = event.detail;
                                                    if (data.name !== 'province' && data.name !== 'city' && data.name !== 'region') {
                                                        return [2 /*return*/];
                                                    }
                                                    colSelectedIndex = data.selectedIndex;
                                                    colOptions = data.options;
                                                    changeData = {};
                                                    changeData[data.name] = {
                                                        value: colOptions[colSelectedIndex].value
                                                    };
                                                    this.updateCityValue(changeData);
                                                    columns = this.generateColumns();
                                                    picker.columns = columns;
                                                    return [4 /*yield*/, this.valiCity(picker)];
                                                case 1:
                                                    _a.sent();
                                                    return [2 /*return*/];
                                            }
                                        });
                                    });
                                }));
                                return [4 /*yield*/, this.valiCity(picker)];
                            case 2:
                                _a.sent();
                                return [4 /*yield*/, picker.present()];
                            case 3:
                                _a.sent();
                                return [2 /*return*/];
                        }
                    });
                });
            };
        /**
         * @private
         * @return {?}
         */
        IonCityPicker.prototype.emitStyle = /**
         * @private
         * @return {?}
         */
            function () {
                this.hasPlaceholder();
                this.ionStyle.emit({
                    'interactive': true,
                    'city': true,
                    'has-placeholder': this.placeholder != null,
                    'has-value': this.hasValue(),
                    'interactive-disabled': this.disabled,
                });
            };
        /**
         * @private
         * @param {?} value
         * @return {?}
         */
        IonCityPicker.prototype.updateCityValue = /**
         * @private
         * @param {?} value
         * @return {?}
         */
            function (value) {
                return __awaiter(this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        this.updateValue(this.cityValue, value, this.separator);
                        return [2 /*return*/];
                    });
                });
            };
        /**
         * @private
         * @return {?}
         */
        IonCityPicker.prototype.generatePickerOptions = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var pickerOptions = __assign({ mode: this.mode }, this.pickerOptions, { columns: this.generateColumns() });
                // If the user has not passed in picker buttons,
                // add a cancel and ok button to the picker
                /** @type {?} */
                var buttons = pickerOptions.buttons;
                if (!buttons || buttons.length === 0) {
                    pickerOptions.buttons = [
                        {
                            text: this.cancelText,
                            handler: ( /**
                             * @param {?} data
                             * @return {?}
                             */function (data) {
                                _this.ionCancel.emit(null);
                            })
                        }, {
                            text: this.doneText,
                            handler: ( /**
                             * @param {?} data
                             * @return {?}
                             */function (data) {
                                _this.value = _this.convertDuration(data, 'value');
                                _this.cityText = _this.convertDuration(data, 'text');
                                _this.updateCityValue(data);
                                _this.emitStyle();
                                _this.ionChange.emit(_this);
                                _this.changeDetectorRef.detectChanges();
                            })
                        }
                    ];
                }
                return pickerOptions;
            };
        /**
         * @private
         * @param {?} durationObject
         * @param {?} type
         * @return {?}
         */
        IonCityPicker.prototype.convertDuration = /**
         * @private
         * @param {?} durationObject
         * @param {?} type
         * @return {?}
         */
            function (durationObject, type) {
                /** @type {?} */
                var province = durationObject.province[type].toString();
                /** @type {?} */
                var city = durationObject.city[type].toString();
                /** @type {?} */
                var region = durationObject.region[type].toString();
                return province + this.separator + city + this.separator + region;
            };
        /**
         * @private
         * @return {?}
         */
        IonCityPicker.prototype.generateColumns = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var columns = [];
                // const values = this.value.toString().split(this.separator);
                // Add province data to picker
                /** @type {?} */
                var provinceCol = {
                    name: 'province',
                    options: this.citiesData.map(( /**
                     * @param {?} province
                     * @return {?}
                     */function (province) { return ({ text: province.name, value: province.code, disabled: false, duration: 100 }); }))
                };
                /** @type {?} */
                var provinceIndex = this.citiesData.findIndex(( /**
                 * @param {?} option
                 * @return {?}
                 */function (option) { return option.code === _this.cityValue.province; }));
                provinceCol.selectedIndex = provinceIndex === -1 ? 0 : provinceIndex;
                columns.push(provinceCol);
                // Add city data to picker
                /** @type {?} */
                var cityColData = this.citiesData[provinceCol.selectedIndex].children;
                /** @type {?} */
                var cityCol = {
                    name: 'city',
                    options: cityColData.map(( /**
                     * @param {?} city
                     * @return {?}
                     */function (city) { return ({ text: city.name, value: city.code, disabled: false, duration: 100 }); }))
                };
                /** @type {?} */
                var cityIndex = cityColData.findIndex(( /**
                 * @param {?} option
                 * @return {?}
                 */function (option) { return option.code === _this.cityValue.city; }));
                cityCol.selectedIndex = cityIndex === -1 ? 0 : cityIndex;
                columns.push(cityCol);
                // Add region data to picker
                /** @type {?} */
                var regionData = this.citiesData[provinceCol.selectedIndex].children[cityCol.selectedIndex].children;
                /** @type {?} */
                var regionColCol = {
                    name: 'region',
                    options: regionData.map(( /**
                     * @param {?} city
                     * @return {?}
                     */function (city) { return ({ text: city.name, value: city.code, disabled: false, duration: 100 }); }))
                };
                /** @type {?} */
                var regionIndex = regionData.findIndex(( /**
                 * @param {?} option
                 * @return {?}
                 */function (option) { return option.code === _this.cityValue.region; }));
                regionColCol.selectedIndex = regionIndex === -1 ? 0 : regionIndex;
                columns.push(regionColCol);
                this.provinceCol = provinceCol.selectedIndex;
                this.cityCol = cityCol.selectedIndex;
                this.regionCol = regionColCol.selectedIndex;
                return this.divyColumns(columns);
            };
        /**
         * @private
         * @param {?} picker
         * @return {?}
         */
        IonCityPicker.prototype.valiCity = /**
         * @private
         * @param {?} picker
         * @return {?}
         */
            function (picker) {
                return __awaiter(this, void 0, void 0, function () {
                    var columns, provinceCol, cityCol, regionCol, cityColData, regionData;
                    return __generator(this, function (_a) {
                        columns = picker.columns;
                        provinceCol = columns[0];
                        cityCol = columns[1];
                        regionCol = columns[2];
                        if (cityCol && this.provinceCol != provinceCol.selectedIndex) {
                            cityCol.selectedIndex = 0;
                            cityColData = this.citiesData[provinceCol.selectedIndex].children;
                            cityCol.options = cityColData.map(( /**
                             * @param {?} city
                             * @return {?}
                             */function (city) { return { text: city.name, value: city.code, disabled: false }; }));
                        }
                        if (regionCol && (this.cityCol != cityCol.selectedIndex || this.provinceCol != provinceCol.selectedIndex)) {
                            regionData = this.citiesData[provinceCol.selectedIndex].children[cityCol.selectedIndex].children;
                            regionCol.selectedIndex = 0;
                            regionCol.options = regionData.map(( /**
                             * @param {?} city
                             * @return {?}
                             */function (city) { return { text: city.name, value: city.code, disabled: false }; }));
                        }
                        this.provinceCol = provinceCol.selectedIndex;
                        this.cityCol = cityCol.selectedIndex;
                        this.regionCol = regionCol.selectedIndex;
                        return [2 /*return*/];
                    });
                });
            };
        /**
         * @param {?} newData
         * @return {?}
         */
        IonCityPicker.prototype.setValue = /**
         * @param {?} newData
         * @return {?}
         */
            function (newData) {
                if (newData === null || newData === undefined) {
                    this.value = '';
                }
                else {
                    this.value = newData;
                }
                this.updateCityValue(this.value);
                this.getText();
            };
        /**
         * @return {?}
         */
        IonCityPicker.prototype.getValue = /**
         * @return {?}
         */
            function () {
                return this.value;
            };
        /**
         * @return {?}
         */
        IonCityPicker.prototype.getText = /**
         * @return {?}
         */
            function () {
                if (this.value === undefined ||
                    this.value === null ||
                    this.value.length === 0) {
                    return;
                }
                this.cityText = this.renderValue(this.value);
                return this.cityText;
            };
        /**
         * @private
         * @return {?}
         */
        IonCityPicker.prototype.hasValue = /**
         * @private
         * @return {?}
         */
            function () {
                /** @type {?} */
                var val = this.cityValue;
                return Object.keys(val).length > 0;
            };
        /**
         * @private
         * @return {?}
         */
        IonCityPicker.prototype.setFocus = /**
         * @private
         * @return {?}
         */
            function () {
                return __awaiter(this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        if (this.buttonEl) {
                            this.buttonEl.focus();
                        }
                        return [2 /*return*/];
                    });
                });
            };
        /**
         * @private
         * @param {?} columns
         * @return {?}
         */
        IonCityPicker.prototype.divyColumns = /**
         * @private
         * @param {?} columns
         * @return {?}
         */
            function (columns) {
                var e_1, _a;
                /** @type {?} */
                var columnsWidth = [];
                /** @type {?} */
                var col;
                /** @type {?} */
                var width;
                for (var i = 0; i < columns.length; i++) {
                    col = columns[i];
                    columnsWidth.push(0);
                    try {
                        for (var _b = __values(col.options), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var option = _c.value;
                            width = ( /** @type {?} */(option.text)).length;
                            if (width > columnsWidth[i]) {
                                columnsWidth[i] = width;
                            }
                        }
                    }
                    catch (e_1_1) {
                        e_1 = { error: e_1_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_1)
                                throw e_1.error;
                        }
                    }
                }
                if (columnsWidth.length === 2) {
                    width = Math.max(columnsWidth[0], columnsWidth[1]);
                    columns[0].align = 'right';
                    columns[1].align = 'left';
                    columns[0].optionsWidth = columns[1].optionsWidth = width * 17 + "px";
                }
                else if (columnsWidth.length === 3) {
                    width = Math.max(columnsWidth[0], columnsWidth[2]);
                    columns[0].align = 'right';
                    columns[2].align = 'left';
                }
                return columns;
            };
        /**
         * @private
         * @param {?} existingData
         * @param {?} newData
         * @param {?} separator
         * @return {?}
         */
        IonCityPicker.prototype.updateValue = /**
         * @private
         * @param {?} existingData
         * @param {?} newData
         * @param {?} separator
         * @return {?}
         */
            function (existingData, newData, separator) {
                var e_2, _a;
                if (newData && newData !== '') {
                    if (typeof newData === 'string') {
                        // new value is a string
                        // convert it to our CityData if a valid
                        newData = this.parseValue(newData);
                        if (newData) {
                            // successfully parsed string to our CityData
                            Object.assign(existingData, newData);
                            return true;
                        }
                    }
                    else if ((newData.province || newData.city || newData.region)) {
                        try {
                            // merge new values from the picker's selection
                            // to the existing CityData values
                            for (var _b = __values(Object.keys(newData)), _c = _b.next(); !_c.done; _c = _b.next()) {
                                var key = _c.value;
                                (( /** @type {?} */(existingData)))[key] = newData[key].value;
                            }
                        }
                        catch (e_2_1) {
                            e_2 = { error: e_2_1 };
                        }
                        finally {
                            try {
                                if (_c && !_c.done && (_a = _b.return))
                                    _a.call(_b);
                            }
                            finally {
                                if (e_2)
                                    throw e_2.error;
                            }
                        }
                        return true;
                    }
                }
                else {
                    // blank data, clear everything out
                    for (var k in existingData) {
                        if (existingData.hasOwnProperty(k)) {
                            delete (( /** @type {?} */(existingData)))[k];
                        }
                    }
                }
                return false;
            };
        /**
         * @private
         * @param {?} val
         * @return {?}
         */
        IonCityPicker.prototype.parseValue = /**
         * @private
         * @param {?} val
         * @return {?}
         */
            function (val) {
                /** @type {?} */
                var parse = null;
                if (val != null && val !== '') {
                    // try parsing for just value first
                    parse = val.split(this.separator);
                }
                if (parse === null) {
                    // wasn't able to parse the value
                    return undefined;
                }
                return {
                    province: parse[0],
                    city: parse[1],
                    region: parse[2]
                };
            };
        /**
         * @private
         * @param {?} val
         * @return {?}
         */
        IonCityPicker.prototype.renderValue = /**
         * @private
         * @param {?} val
         * @return {?}
         */
            function (val) {
                var _this = this;
                /** @type {?} */
                var parse = null;
                if (val != null && val !== '') {
                    // try parsing for just value first
                    parse = val.split(this.separator);
                }
                if (parse === null) {
                    // wasn't able to parse the value
                    return undefined;
                }
                /** @type {?} */
                var textValue;
                this.citiesData.forEach(( /**
                 * @param {?} pro
                 * @return {?}
                 */function (pro) {
                    if (pro.code !== parse[0]) {
                        return;
                    }
                    textValue = pro.name;
                    pro.children.forEach(( /**
                     * @param {?} city
                     * @return {?}
                     */function (city) {
                        if (city.code !== parse[1]) {
                            return;
                        }
                        textValue = textValue + _this.separator + city.name;
                        city.children.forEach(( /**
                         * @param {?} reg
                         * @return {?}
                         */function (reg) {
                            if (reg.code !== parse[2]) {
                                return;
                            }
                            textValue = textValue + _this.separator + reg.name;
                        }));
                    }));
                }));
                return textValue;
            };
        /**
         * @private
         * @return {?}
         */
        IonCityPicker.prototype.hasPlaceholder = /**
         * @private
         * @return {?}
         */
            function () {
                return __awaiter(this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        this.addPlaceholderClass =
                            (this.getText() === undefined && this.placeholder != null) ? true : false;
                        return [2 /*return*/];
                    });
                });
            };
        /**
         * @private
         * @return {?}
         */
        IonCityPicker.prototype.hasReadonly = /**
         * @private
         * @return {?}
         */
            function () {
                return __awaiter(this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        this.readonly =
                            (this.readonly.toString() === '' || this.readonly.toString() === 'true' || this.readonly === true) ? true : false;
                        return [2 /*return*/];
                    });
                });
            };
        /**
         * @private
         * @return {?}
         */
        IonCityPicker.prototype.hasDisable = /**
         * @private
         * @return {?}
         */
            function () {
                return __awaiter(this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        this.disabled =
                            (this.disabled.toString() === '' || this.disabled.toString() === 'true' || this.disabled === true) ? true : false;
                        return [2 /*return*/];
                    });
                });
            };
        IonCityPicker.decorators = [
            { type: core.Component, args: [{
                        selector: 'ionic4-city-picker',
                        template: '<div class="city-picker-text">{{cityText}}</div>' +
                            '<button type="button"  ' +
                            'role="ombobox" ' +
                            'aria-haspopup="true"  ' +
                            '[attr.aria-labelledby]="labelId" ' +
                            '[attr.aria-disabled]="disabled" ' +
                            '[attr.aria-expanded]="isExpanded" ' +
                            'class="city-picker-button">' +
                            '</button>',
                        host: {
                            '[class.city-picker-disabled]': 'disabled',
                            '[class.city-picker-readonly]': 'readonly',
                            '[class.city-picker-placeholder]': 'addPlaceholderClass'
                        },
                        providers: [CITY_PICKER_VALUE_ACCESSOR],
                        encapsulation: core.ViewEncapsulation.None,
                        styles: ["ion-city-picker{padding-top:10px;padding-bottom:10px;display:flex;overflow:hidden}.city-picker-button{left:0;top:0;position:absolute;width:100%;height:100%;border:0;background:0 0;cursor:pointer;-webkit-appearance:none;-moz-appearance:none;appearance:none;outline:0;margin:0}.city-picker-text{margin-right:8px;font-family:inherit;font-size:inherit;font-style:inherit;font-weight:inherit;letter-spacing:inherit;text-decoration:inherit;text-overflow:inherit;text-transform:inherit;text-align:inherit;white-space:inherit;color:inherit;flex:1;min-height:inherit;direction:ltr;overflow:inherit}.item-label-floating city-picker,.item-label-stacked city-picker{padding-left:0;width:100%}.picker-opt{margin-left:4px;font-size:18px}.picker-opts-left .picker-opts .picker-opt{margin-left:-8px}.picker-opts-right .picker-opts .picker-opt{margin-left:15px}.in-item{position:static}.city-picker-placeholder{color:#999}.city-picker-disabled,.item-city-picker-disabled ion-label{opacity:.3;pointer-events:none}.city-picker-readonly{pointer-events:none}"]
                    }] }
        ];
        /** @nocollapse */
        IonCityPicker.ctorParameters = function () {
            return [
                { type: angular.PickerController },
                { type: core.ChangeDetectorRef }
            ];
        };
        IonCityPicker.propDecorators = {
            value: [{ type: core.Input }],
            mode: [{ type: core.Input }],
            name: [{ type: core.Input }],
            disabled: [{ type: core.Input }],
            readonly: [{ type: core.Input }],
            pickerOptions: [{ type: core.Input }],
            cancelText: [{ type: core.Input }],
            doneText: [{ type: core.Input }],
            citiesData: [{ type: core.Input }],
            separator: [{ type: core.Input }],
            placeholder: [{ type: core.Input }],
            ionChange: [{ type: core.Output }],
            ionCancel: [{ type: core.Output }],
            ionStyle: [{ type: core.Output }],
            onClick: [{ type: core.HostListener, args: ['click', ['$event.target'],] }]
        };
        return IonCityPicker;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var IonCityPickerModule = /** @class */ (function () {
        function IonCityPickerModule() {
        }
        IonCityPickerModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [IonCityPicker],
                        imports: [],
                        exports: [IonCityPicker]
                    },] }
        ];
        return IonCityPickerModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.IonCityPickerModule = IonCityPickerModule;
    exports.CITY_PICKER_VALUE_ACCESSOR = CITY_PICKER_VALUE_ACCESSOR;
    exports.IonCityPicker = IonCityPicker;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ionic4-city-picker.umd.js.map